#include "dfpfx.h"

struct ENEMY Enm[ENEMY_MAX];
int Frame;

void EnemyInit(void)
{
	int i;

	Frame = 0;
	ELM_Init();

	for(i=0;i<ENEMY_MAX;i++){
		Enm[i].f = 0;
	}
}

void EnemyFrameControl(void)
{
	EnemyCreateScript();
	EnemyShotScript();
}

void EnemyCreateScript(void)
{
	Frame++;

	//ELM_Create(int bt,int x,int y,int life,int r,int score,int spd,int gx,int gy)
	switch(Frame){
		case  1:ELM_Create(1,0,0,1,5,10,10,GW_WIDTH/2,GW_HEIGHT);
				break;
		case 40:ELM_Create(1,GW_WIDTH,GW_HEIGHT,1,5,10,10,0,0);
				break;
		case 41:ELM_Create(1,0,0,1,5,10,10,GW_WIDTH,GW_HEIGHT);
				break;
		case 80:ELM_Create(1,0,GW_HEIGHT/2,10,5,10,10,GW_WIDTH,GW_HEIGHT/2);
				ELM_Create(1,GW_WIDTH,GW_HEIGHT/2,10,5,10,10,0,GW_HEIGHT/2);
				break;
		case 100:ELM_Create(1,GW_WIDTH/2,0,10,5,10,10,GW_WIDTH/2,GW_HEIGHT);
				 ELM_Create(1,0,GW_HEIGHT/2,10,5,10,10,GW_WIDTH,GW_HEIGHT/2);
	}
}

void EnemyShotScript(void)
{
	int i;
	
	for(i=0;i<ENEMY_MAX;i++){
		if(Enm[i].f){
			Enm[i].frame++;

			/*---Geev[g---*/
			switch(Enm[i].bt){
				case 1:	//ev[g1F@_e
						//BJL_Create(int x,int y,int r,int pow,int spd,int gx,int gy)
						if(Enm[i].frame&&!EnemyInOfWindowJudge(i)){ BJL_Create(Enm[i].x,Enm[i].y,5,1,20,MyS.x,MyS.y); }
						break;
				default:
						break;
			}
		}
	}
}

void EnemyStatusCheckAll(void)
{
	int i;

	for(i=0;i<ENEMY_MAX;i++){
		if(Enm[i].f){
			EnemyStatusCheck(i);
		}
	}
}

void EnemyStatusCheck(int num)
{
	if(Enm[num].life<0){ EnemyDelete(num); }
}

void EnemyDraw(HDC hdc)
{
	int i;

	/*---EnemyDraw---*/
	//G@̍W𒆐SƂlp`
	for(i=0;i<ENEMY_MAX;i++){
		if(Enm[i].f){
			Rectangle(hdc,Enm[i].x-5,Enm[i].y-5,Enm[i].x+5,Enm[i].y+5);
			Ellipse(hdc,Enm[i].x-Enm[i].r,Enm[i].y-Enm[i].r,Enm[i].x+Enm[i].r,Enm[i].y+Enm[i].r);
		}
	}
}

void EnemyMove(void)
{
	int i;

	for(i=0;i<ENEMY_MAX;i++){
		if(Enm[i].f){
			switch(Enm[i].type){
				case ENAT_ELM:	ELM_move(i);
								break;
				default:		break;

			}
		}
	}
}

void EnemyOutOfWindow(void)
{
	int i;
	
	for(i=0;i<ENEMY_MAX;i++){
		if(Enm[i].f){
			if(EnemyOutOfWindowJudge(i)){ EnemyDelete(i); }
		}
	}
}

//肷邾
int EnemyOutOfWindowJudge(int i)
{
	if(Enm[i].x<=GWC_OUT_LEFT||GWC_OUT_RIGHT<=Enm[i].x||Enm[i].y<=GWC_OUT_TOP||GWC_OUT_BOTTOM<=Enm[i].y)
	{
		return 1;
	}

	return 0;
}

int EnemyInOfWindowJudge(int i)
{
	if(Enm[i].x<=0||GWC_WIDTH<=Enm[i].x||Enm[i].y<=0||GWC_HEIGHT<=Enm[i].y)
	{
		return 1;
	}

	return 0;
}

void EnemyDamage(int num,int dm)
{
	Enm[num].life -= dm;
	EnemyStatusCheck(num);
}

void EnemyDelete(int num)
{
	Enm[num].f = 0;

	switch(Enm[num].type){
		case ENAT_ELM: ELM_Delete(Enm[num].num);
			break;
		default: break;
	}
}