#include <windows.h>
#include <time.h>
#include <stdlib.h>
#include <math.h>

//VXe
#define true	1
#define	false	0

//eǗ(BulletAttribute)
#define BUAT_BJL		1

//GǗ(EnemyAttribute)
#define ENAT_ELM		1

//eǗ

//ő吔ݒ
#define ENEMY_MAX		255
#define BULLET_MAX		255

//GameWindow(Margine)
#define GW_WIDTH		310
#define GW_HEIGHT		430
#define GW_M_LEFT		10
#define GW_M_TOP		10

//pQ[EBhETCY(GameWindowChild)
#define GWC_WIDTH	GW_WIDTH-GW_M_LEFT
#define	GWC_HEIGHT	GW_HEIGHT-GW_M_TOP

//G,ẻʊOpg(ނ킩ɂH)
#define	GWC_OUT_MARGINE	20
#define GWC_OUT_RIGHT	GWC_WIDTH + GWC_OUT_MARGINE
#define GWC_OUT_BOTTOM	GWC_HEIGHT + GWC_OUT_MARGINE
#define GWC_OUT_TOP		-GWC_OUT_MARGINE
#define GWC_OUT_LEFT	-GWC_OUT_MARGINE

/*---KeyControl.c---*/
void KeyControlMove(void);
void KeySet(WPARAM wParam);
void KeyFree(WPARAM wParam);

/*---System.c---*/
void Initialize(void);
void GameOver(void);
void DrawAll(HDC hdc);
void Update(void);
void StatusCheck(void);
void FrameControl(void);
void EnemyControl(void);
void BulletControl(void);
void HitJudge(void);
void HitJudgeEnemyOnMyShip(void);
void HitJudgeEnemyBulletOnMyShip(void);

/*---MyShip.c---*/
void MyShipInit(void);
void MyShipStatusCheck(void);
void MyShipDraw(HDC hdc);
void MyShipReSet(void);
void MyShipMove(int Direction);
void MyShipDamage(int dm);
void MyShipDeath(void);

/*---Enemy.c---*/
void EnemyInit(void);
void EnemyFrameControl(void);
void EnemyCreateScript(void);
void EnemyShotScript(void);
void EnemyStatusCheckAll(void);
void EnemyStatusCheck(int num);
void EnemyDraw(HDC hdc);
void EnemyOutOfWindow(void);
int EnemyOutOfWindowJudge(int i);
int EnemyInOfWindowJudge(int i);
void EnemyMove(void);
void EnemyDelete(int num);

/*---Bullet.c---*/
void BulletInit(void);
void BulletFrameControl(void);
void BulletDraw(HDC hdc);
void BulletOutOfWindow(void);
void BulletMove(void);
void BulletDelete(int num);

/*---BulletJikiLock.c---*/
void BJL_Init(void);
int BJL_Create(int x,int y,int r,int pow,int spd,int gx,int gy);
void BJL_move(int num);
void BJL_Delete(int num);

/*---EnemyLineMove.c---*/
void ELM_Init(void);
int ELM_Create(int bt,int x,int y,int life,int r,int score,int spd,int gx,int gy);
void ELM_move(int num);	//moveł̂݌ĂяoBt[Rg[pꍇ
void ELM_Delete(int num);

struct PLAYER {
	BOOL	f;			//Q[ۂ
	BOOL	gameover;	//Q[I[o[ǂ
	BOOL	pause;		//|[Yۂ
};

struct MYSHIP {
	BOOL	f;		//tO
	float	x;		//xW
	float	y;		//yW
	float	spd;	//Xs[h
	int		life;	//̗
	int		left;	//c@
	int		btype;	//e^Cv
	float	r;		//͈͂̔a
	BOOL	mt;		//GԃtO
};

struct ENEMY {
	BOOL	f;		//tO
	int		type;	//G^Cv
	int		bt;		//e^Cv
	int		num;	//G^Cv̊Ǘԍ(z̓Y)
	float	x;		//xW
	float	y;		//yW
	int		life;	//̗
	float	r;		//͈͂̔a
	int		score;	//ۗLXRA
	int		frame;	//t[
};

struct BULLET {
	BOOL	f;		//tO
	int		type;	//e^Cv
	int		num;	//e^Cv̊Ǘԍ(z̓Y)
	float	x;		//xW
	float	y;		//yW
	float	r;		//͈͂̔a
	int		pow;	//З
	int		frame;	//t[
};

extern struct PLAYER Plyr;				//vC[
extern struct MYSHIP MyS;				//@
extern struct ENEMY Enm[ENEMY_MAX];		//ɓWJłG̍ő吔
extern struct BULLET Bul[BULLET_MAX];	//ɓWJłGe̍ő吔
extern struct BULLET MyBul[BULLET_MAX];	//@e