#include "dfpfx.h"

#define BJL_MAX 255

struct BJL {
	BOOL	 f;		//tO
	int		spd;	//Xs[h
	float	vx;		//x̑x
	float	vy;		//y̑x
}Bjl[BJL_MAX];

void BJL_Init(void)
{
	int i;

	for(i=0;i<BJL_MAX;i++){
		Bjl[i].f = 0;
	}
}

int BJL_Create(int x,int y,int r,int pow,int spd,int gx,int gy)
{
	int i,j;
	float d;	//v
	float tempx,tempy;

	for(i=0;i<BULLET_MAX;i++){
		if(i==BULLET_MAX-1){ return 0; }
		if(!Bul[i].f){
			Bul[i].f = 1;
			Bul[i].type = BUAT_BJL;
			Bul[i].x = x;
			Bul[i].y = y;
			Bul[i].r = r;
			Bul[i].pow = pow;
			Bul[i].frame = 0;

			/*---eŗL̋L^---*/
			for(j=0;j<BJL_MAX;j++){
				if(i==BJL_MAX-1){ return 0; }
				if(!Bjl[j].f){
					Bul[i].num = j;

					Bjl[j].f = 1;
					Bjl[j].spd = spd;

					d = sqrt((gx-x)*(gx-x)+(gy-y)*(gy-y));
					Bjl[j].vx = (gx-x)/d*spd;
					Bjl[j].vy = (gy-y)/d*spd;
					if(d==0){ 
						Bjl[j].vx = 0; Bjl[j].vy = spd;
					}
					return 1;
				}
			}
			/*---܂---*/
		}
	}

	return 0;
}

void BJL_move(int num)
{
	Bul[num].x += Bjl[Bul[num].num].vx;
	Bul[num].y += Bjl[Bul[num].num].vy;
}

void BJL_Delete(int num)
{
	Bjl[num].f = 0;
}