#include "dfpfx.h"

struct PLAYER Plyr;

//vC[֐͗܂ʃt@CɊu\L
void PlayerInit(void)
{
	Plyr.f = 0;
	Plyr.gameover = 0;
	Plyr.pause = 0;
}

void Initialize(void)
{
	PlayerInit();
	EnemyInit();
	BulletInit();
	MyShipInit();
}

void GameOver(void)
{
	Plyr.pause = true;
	Plyr.gameover = true;
}

void DrawAll(HDC hdc)
{
	EnemyDraw(hdc);	
	BulletDraw(hdc);
	MyShipDraw(hdc);
}

void Update(void)
{
	if(!Plyr.pause){
		KeyControlMove();
		FrameControl();
		EnemyControl();
		BulletControl();
		HitJudge();
		StatusCheck();
	}
}

//ԃ`FbN
void StatusCheck(void)
{
	MyShipStatusCheck();
	EnemyStatusCheckAll();
}

//t[Rg[
void FrameControl(void)
{
	static int Frame = 0;

	Frame++;

	EnemyFrameControl();
	//BulletFrameControl();
}

//GړRg[@܂Kv͔BX
void EnemyControl(void)
{
	EnemyMove();
}

//eړRg[
void BulletControl(void)
{
	BulletMove();
}

//蔻
void HitJudge(void)
{
	EnemyOutOfWindow();
	BulletOutOfWindow();
	HitJudgeEnemyOnMyShip();
	HitJudgeEnemyBulletOnMyShip();
}

void HitJudgeEnemyOnMyShip(void)
{
	int i;

	for(i=0;i<ENEMY_MAX;i++){
		if(Enm[i].f){
			if( ((Enm[i].x-MyS.x)*(Enm[i].x-MyS.x)+(Enm[i].y-MyS.y)*(Enm[i].y-MyS.y)) < (Enm[i].r+MyS.r)*(Enm[i].r+MyS.r) )
			{
				/*---GƎ@̏Փˏ---*/
				if(!MyS.mt){
					MyShipDamage(Enm[i].life);
					if(MyS.life > 0){ EnemyDamage(i,MyS.life); }
				}
			}
		}
	}
}

void HitJudgeEnemyBulletOnMyShip(void)
{
	int i;

	for(i=0;i<BULLET_MAX;i++){
		if(Bul[i].f){
			if( ((Bul[i].x-MyS.x)*(Bul[i].x-MyS.x)+(Bul[i].y-MyS.y)*(Bul[i].y-MyS.y)) < (Bul[i].r+MyS.r)*(Bul[i].r+MyS.r) )
			{
				/*---eƎ@̏Փˏ---*/
				if(!MyS.mt){
					MyShipDamage(Bul[i].pow);
					BulletDelete(i);
				}
			}
		}
	}
}